From 212ab2a48d7b0b17963b7eefd138520afc22f279 Mon Sep 17 00:00:00 2001
From: Nicolas ROCHE <nroche@entrouvert.com>
Date: Fri, 9 Aug 2019 17:05:20 +0200
Subject: [PATCH] fonts: add Work Sans (#35343)

---
 README                                        |   7 +++++
 .../WorkSans/worksans-black-webfont.woff      | Bin 0 -> 30068 bytes
 .../WorkSans/worksans-black-webfont.woff2     | Bin 0 -> 22792 bytes
 .../worksans-blackitalic-webfont.woff         | Bin 0 -> 32296 bytes
 .../worksans-blackitalic-webfont.woff2        | Bin 0 -> 24368 bytes
 .../fonts/WorkSans/worksans-bold-webfont.woff | Bin 0 -> 33220 bytes
 .../WorkSans/worksans-bold-webfont.woff2      | Bin 0 -> 25344 bytes
 .../WorkSans/worksans-bolditalic-webfont.woff | Bin 0 -> 36244 bytes
 .../worksans-bolditalic-webfont.woff2         | Bin 0 -> 28432 bytes
 .../WorkSans/worksans-extrabold-webfont.woff  | Bin 0 -> 32660 bytes
 .../WorkSans/worksans-extrabold-webfont.woff2 | Bin 0 -> 25064 bytes
 .../worksans-extrabolditalic-webfont.woff     | Bin 0 -> 35688 bytes
 .../worksans-extrabolditalic-webfont.woff2    | Bin 0 -> 27236 bytes
 .../WorkSans/worksans-extralight-webfont.woff | Bin 0 -> 32628 bytes
 .../worksans-extralight-webfont.woff2         | Bin 0 -> 25124 bytes
 .../worksans-extralightitalic-webfont.woff    | Bin 0 -> 36376 bytes
 .../worksans-extralightitalic-webfont.woff2   | Bin 0 -> 27860 bytes
 .../WorkSans/worksans-hairline-webfont.woff   | Bin 0 -> 30256 bytes
 .../WorkSans/worksans-hairline-webfont.woff2  | Bin 0 -> 23668 bytes
 .../WorkSans/worksans-italic-vf-webfont.woff  | Bin 0 -> 38344 bytes
 .../WorkSans/worksans-italic-vf-webfont.woff2 | Bin 0 -> 28676 bytes
 .../WorkSans/worksans-italic-webfont.woff     | Bin 0 -> 34784 bytes
 .../WorkSans/worksans-italic-webfont.woff2    | Bin 0 -> 26592 bytes
 .../WorkSans/worksans-light-webfont.woff      | Bin 0 -> 32324 bytes
 .../WorkSans/worksans-light-webfont.woff2     | Bin 0 -> 24768 bytes
 .../worksans-lightitalic-webfont.woff         | Bin 0 -> 36200 bytes
 .../worksans-lightitalic-webfont.woff2        | Bin 0 -> 28576 bytes
 .../WorkSans/worksans-medium-webfont.woff     | Bin 0 -> 33252 bytes
 .../WorkSans/worksans-medium-webfont.woff2    | Bin 0 -> 25512 bytes
 .../worksans-mediumitalic-webfont.woff        | Bin 0 -> 36600 bytes
 .../worksans-mediumitalic-webfont.woff2       | Bin 0 -> 28192 bytes
 .../WorkSans/worksans-regular-webfont.woff    | Bin 0 -> 31520 bytes
 .../WorkSans/worksans-regular-webfont.woff2   | Bin 0 -> 24088 bytes
 .../WorkSans/worksans-roman-vf-webfont.woff   | Bin 0 -> 46816 bytes
 .../WorkSans/worksans-roman-vf-webfont.woff2  | Bin 0 -> 33776 bytes
 .../WorkSans/worksans-semibold-webfont.woff   | Bin 0 -> 32976 bytes
 .../WorkSans/worksans-semibold-webfont.woff2  | Bin 0 -> 25280 bytes
 .../worksans-semibolditalic-webfont.woff      | Bin 0 -> 36620 bytes
 .../worksans-semibolditalic-webfont.woff2     | Bin 0 -> 28820 bytes
 .../fonts/WorkSans/worksans-thin-webfont.woff | Bin 0 -> 30992 bytes
 .../WorkSans/worksans-thin-webfont.woff2      | Bin 0 -> 24284 bytes
 .../WorkSans/worksans-thinitalic-webfont.woff | Bin 0 -> 35248 bytes
 .../worksans-thinitalic-webfont.woff2         | Bin 0 -> 26916 bytes
 static/includes/_font-worksans.scss           |  26 ++++++++++++++++++
 44 files changed, 33 insertions(+)
 create mode 100644 static/fonts/WorkSans/worksans-black-webfont.woff
 create mode 100644 static/fonts/WorkSans/worksans-black-webfont.woff2
 create mode 100644 static/fonts/WorkSans/worksans-blackitalic-webfont.woff
 create mode 100644 static/fonts/WorkSans/worksans-blackitalic-webfont.woff2
 create mode 100644 static/fonts/WorkSans/worksans-bold-webfont.woff
 create mode 100644 static/fonts/WorkSans/worksans-bold-webfont.woff2
 create mode 100644 static/fonts/WorkSans/worksans-bolditalic-webfont.woff
 create mode 100644 static/fonts/WorkSans/worksans-bolditalic-webfont.woff2
 create mode 100644 static/fonts/WorkSans/worksans-extrabold-webfont.woff
 create mode 100644 static/fonts/WorkSans/worksans-extrabold-webfont.woff2
 create mode 100644 static/fonts/WorkSans/worksans-extrabolditalic-webfont.woff
 create mode 100644 static/fonts/WorkSans/worksans-extrabolditalic-webfont.woff2
 create mode 100644 static/fonts/WorkSans/worksans-extralight-webfont.woff
 create mode 100644 static/fonts/WorkSans/worksans-extralight-webfont.woff2
 create mode 100644 static/fonts/WorkSans/worksans-extralightitalic-webfont.woff
 create mode 100644 static/fonts/WorkSans/worksans-extralightitalic-webfont.woff2
 create mode 100644 static/fonts/WorkSans/worksans-hairline-webfont.woff
 create mode 100644 static/fonts/WorkSans/worksans-hairline-webfont.woff2
 create mode 100644 static/fonts/WorkSans/worksans-italic-vf-webfont.woff
 create mode 100644 static/fonts/WorkSans/worksans-italic-vf-webfont.woff2
 create mode 100644 static/fonts/WorkSans/worksans-italic-webfont.woff
 create mode 100644 static/fonts/WorkSans/worksans-italic-webfont.woff2
 create mode 100644 static/fonts/WorkSans/worksans-light-webfont.woff
 create mode 100644 static/fonts/WorkSans/worksans-light-webfont.woff2
 create mode 100644 static/fonts/WorkSans/worksans-lightitalic-webfont.woff
 create mode 100644 static/fonts/WorkSans/worksans-lightitalic-webfont.woff2
 create mode 100644 static/fonts/WorkSans/worksans-medium-webfont.woff
 create mode 100644 static/fonts/WorkSans/worksans-medium-webfont.woff2
 create mode 100644 static/fonts/WorkSans/worksans-mediumitalic-webfont.woff
 create mode 100644 static/fonts/WorkSans/worksans-mediumitalic-webfont.woff2
 create mode 100644 static/fonts/WorkSans/worksans-regular-webfont.woff
 create mode 100644 static/fonts/WorkSans/worksans-regular-webfont.woff2
 create mode 100644 static/fonts/WorkSans/worksans-roman-vf-webfont.woff
 create mode 100644 static/fonts/WorkSans/worksans-roman-vf-webfont.woff2
 create mode 100644 static/fonts/WorkSans/worksans-semibold-webfont.woff
 create mode 100644 static/fonts/WorkSans/worksans-semibold-webfont.woff2
 create mode 100644 static/fonts/WorkSans/worksans-semibolditalic-webfont.woff
 create mode 100644 static/fonts/WorkSans/worksans-semibolditalic-webfont.woff2
 create mode 100644 static/fonts/WorkSans/worksans-thin-webfont.woff
 create mode 100644 static/fonts/WorkSans/worksans-thin-webfont.woff2
 create mode 100644 static/fonts/WorkSans/worksans-thinitalic-webfont.woff
 create mode 100644 static/fonts/WorkSans/worksans-thinitalic-webfont.woff2
 create mode 100644 static/includes/_font-worksans.scss

diff --git a/README b/README
index 4f39206f..0fabd32e 100644
--- a/README
+++ b/README
@@ -174,12 +174,19 @@ copyright notices:
 * Abel
   # Copyright (c) 2011, Matthew Desmond (http://www.madtype.com | mattdesmond@gmail.com),
   # with Reserved Font Name Abel.
   #
   # This Font Software is licensed under the SIL Open Font License, Version 1.1.
   #
   # https://www.fontsquirrel.com/license/abel
 
+* Work Sans
+  # Copyright (c) 2014-2015 Wei Huang (wweeiihhuuaanngg@gmail.com)
+  #
+  # This Font Software is licensed under the SIL Open Font License, Version 1.1.
+  #
+  # https://www.fontsquirrel.com/license/work-sans
+
 ~~~~
 
 Some theme variant files have their own specific licenses; refer to
 static/$theme/README for details.
diff --git a/static/fonts/WorkSans/worksans-black-webfont.woff b/static/fonts/WorkSans/worksans-black-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..738328cc4923222e5a0ab39ea5bfb421fa50c96b
GIT binary patch
diff --git a/static/fonts/WorkSans/worksans-black-webfont.woff2 b/static/fonts/WorkSans/worksans-black-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..73a2aad4d32bcc6005647466f140bb9235690af0
GIT binary patch
diff --git a/static/fonts/WorkSans/worksans-blackitalic-webfont.woff b/static/fonts/WorkSans/worksans-blackitalic-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..99b6b50ed29f1339be7b8aa9b4ccbfae56474914
GIT binary patch
diff --git a/static/fonts/WorkSans/worksans-blackitalic-webfont.woff2 b/static/fonts/WorkSans/worksans-blackitalic-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..cd7815ff1d659a91d95ac1fa907756a3f92bf830
GIT binary patch
diff --git a/static/fonts/WorkSans/worksans-bold-webfont.woff b/static/fonts/WorkSans/worksans-bold-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..fc1999ec1a4caeca9b8595a05057e559dadc3fba
GIT binary patch
diff --git a/static/fonts/WorkSans/worksans-bold-webfont.woff2 b/static/fonts/WorkSans/worksans-bold-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..3f5460d68f6e3a0e6008ad977c330ebd05f293b2
GIT binary patch
diff --git a/static/fonts/WorkSans/worksans-bolditalic-webfont.woff b/static/fonts/WorkSans/worksans-bolditalic-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..84ecd81eaf77e03933c60fb2654e45729ee37c72
GIT binary patch
diff --git a/static/fonts/WorkSans/worksans-bolditalic-webfont.woff2 b/static/fonts/WorkSans/worksans-bolditalic-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..655766949a1d341a26fd697ba456e93b897b9216
GIT binary patch
diff --git a/static/fonts/WorkSans/worksans-extrabold-webfont.woff b/static/fonts/WorkSans/worksans-extrabold-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..ff256f1952073a858590ad0d8e4af1cbe7e4bb23
GIT binary patch
diff --git a/static/fonts/WorkSans/worksans-extrabold-webfont.woff2 b/static/fonts/WorkSans/worksans-extrabold-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..9358a60c1610ef58731f02b6794406a8299b6126
GIT binary patch
diff --git a/static/fonts/WorkSans/worksans-extrabolditalic-webfont.woff b/static/fonts/WorkSans/worksans-extrabolditalic-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..bdf81b325d2eca820e5ba7eb6f297f95d63bd7ee
GIT binary patch
diff --git a/static/fonts/WorkSans/worksans-extrabolditalic-webfont.woff2 b/static/fonts/WorkSans/worksans-extrabolditalic-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..89c7cb14cc4a3124e6eefdae614c96313361b62c
GIT binary patch
diff --git a/static/fonts/WorkSans/worksans-extralight-webfont.woff b/static/fonts/WorkSans/worksans-extralight-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..23e352def3ad2417e40072ab22ba30b5224129d4
GIT binary patch
diff --git a/static/fonts/WorkSans/worksans-extralight-webfont.woff2 b/static/fonts/WorkSans/worksans-extralight-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..083f12a79a0eed8ef44872d52e1b1286bfe04468
GIT binary patch
diff --git a/static/fonts/WorkSans/worksans-extralightitalic-webfont.woff b/static/fonts/WorkSans/worksans-extralightitalic-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..4730d5b20465553c86243959a7775a2c7f42dafe
GIT binary patch
diff --git a/static/fonts/WorkSans/worksans-extralightitalic-webfont.woff2 b/static/fonts/WorkSans/worksans-extralightitalic-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..47b477470f9d8cee16546ec7edb3549cbda33a3d
GIT binary patch
diff --git a/static/fonts/WorkSans/worksans-hairline-webfont.woff b/static/fonts/WorkSans/worksans-hairline-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..019f446d0780247a510c871c383ee68c732acc4f
GIT binary patch
diff --git a/static/fonts/WorkSans/worksans-hairline-webfont.woff2 b/static/fonts/WorkSans/worksans-hairline-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..623d99549d9265bb8ffaa1db5be0c456c2a99a8e
GIT binary patch
diff --git a/static/fonts/WorkSans/worksans-italic-vf-webfont.woff b/static/fonts/WorkSans/worksans-italic-vf-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..f729fb463dd7ece2223c1199ca3b430053e89e30
GIT binary patch
diff --git a/static/fonts/WorkSans/worksans-italic-vf-webfont.woff2 b/static/fonts/WorkSans/worksans-italic-vf-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..3b00d2f654b8f929f0ca7a871c8dc34cd3d5e707
GIT binary patch
diff --git a/static/fonts/WorkSans/worksans-italic-webfont.woff b/static/fonts/WorkSans/worksans-italic-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..757ca813a73328528c7cf6ba942d073308d90174
GIT binary patch
diff --git a/static/fonts/WorkSans/worksans-italic-webfont.woff2 b/static/fonts/WorkSans/worksans-italic-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..4bc9a914ef846f09251d45122728f58b3c147881
GIT binary patch
diff --git a/static/fonts/WorkSans/worksans-light-webfont.woff b/static/fonts/WorkSans/worksans-light-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..4795c4263dd5f41e6e63798a09a158a2d2fc235a
GIT binary patch
diff --git a/static/fonts/WorkSans/worksans-light-webfont.woff2 b/static/fonts/WorkSans/worksans-light-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..29cdf78b9b6c149e40f5e403e24001451984473c
GIT binary patch
diff --git a/static/fonts/WorkSans/worksans-lightitalic-webfont.woff b/static/fonts/WorkSans/worksans-lightitalic-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..373732096c35b9bdd906352ae6faf751897f8cac
GIT binary patch
diff --git a/static/fonts/WorkSans/worksans-lightitalic-webfont.woff2 b/static/fonts/WorkSans/worksans-lightitalic-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..5faaf5ae89906c1c33ac22f6a7ff1137efaf3929
GIT binary patch
diff --git a/static/fonts/WorkSans/worksans-medium-webfont.woff b/static/fonts/WorkSans/worksans-medium-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..6819d32960b0c00539a9e80bdf18b3813cbc5945
GIT binary patch
diff --git a/static/fonts/WorkSans/worksans-medium-webfont.woff2 b/static/fonts/WorkSans/worksans-medium-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..03bda4f35a438b0a0e061a1d3b42f0077272c22b
GIT binary patch
diff --git a/static/fonts/WorkSans/worksans-mediumitalic-webfont.woff b/static/fonts/WorkSans/worksans-mediumitalic-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..21d4b442195f1bfc7dbb9214aa4609be80051b32
GIT binary patch
diff --git a/static/fonts/WorkSans/worksans-mediumitalic-webfont.woff2 b/static/fonts/WorkSans/worksans-mediumitalic-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..c626cc6852029d658ae13b427a45ffe66bc6315a
GIT binary patch
diff --git a/static/fonts/WorkSans/worksans-regular-webfont.woff b/static/fonts/WorkSans/worksans-regular-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..8175d94b4d4fffa3cfa09b6d1156c41e8adcfc36
GIT binary patch
diff --git a/static/fonts/WorkSans/worksans-regular-webfont.woff2 b/static/fonts/WorkSans/worksans-regular-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..2ec22edc10458878d572478f5ce522f879d6796f
GIT binary patch
diff --git a/static/fonts/WorkSans/worksans-roman-vf-webfont.woff b/static/fonts/WorkSans/worksans-roman-vf-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..8fbd6298c3289e14100d0148cf69478a18c59eb2
GIT binary patch
diff --git a/static/fonts/WorkSans/worksans-roman-vf-webfont.woff2 b/static/fonts/WorkSans/worksans-roman-vf-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..6537b7b8b7575279635871bdf6dc436e7cf1bcd9
GIT binary patch
diff --git a/static/fonts/WorkSans/worksans-semibold-webfont.woff b/static/fonts/WorkSans/worksans-semibold-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..060892326a838e217d30bd61d0bc426ce051e01c
GIT binary patch
diff --git a/static/fonts/WorkSans/worksans-semibold-webfont.woff2 b/static/fonts/WorkSans/worksans-semibold-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..498a73d6a1bc22e2f950c48c5c9ac698edfea8cb
GIT binary patch
diff --git a/static/fonts/WorkSans/worksans-semibolditalic-webfont.woff b/static/fonts/WorkSans/worksans-semibolditalic-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..03504e60f9dfaaba44d1fa129e18f4be3a7bfa24
GIT binary patch
diff --git a/static/fonts/WorkSans/worksans-semibolditalic-webfont.woff2 b/static/fonts/WorkSans/worksans-semibolditalic-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..1788e7cd5037e5d599cbcb53b4a5dca2923b2dd7
GIT binary patch
diff --git a/static/fonts/WorkSans/worksans-thin-webfont.woff b/static/fonts/WorkSans/worksans-thin-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..67d391251504dc8e694b9c092bb02ad34c55c687
GIT binary patch
diff --git a/static/fonts/WorkSans/worksans-thin-webfont.woff2 b/static/fonts/WorkSans/worksans-thin-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..2745ea6c52d8a1d7817dcd38db9825754ddf8bbd
GIT binary patch
diff --git a/static/fonts/WorkSans/worksans-thinitalic-webfont.woff b/static/fonts/WorkSans/worksans-thinitalic-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..1d83bcf5bd6d8c772152bc47ef8eaa38a280816d
GIT binary patch
diff --git a/static/fonts/WorkSans/worksans-thinitalic-webfont.woff2 b/static/fonts/WorkSans/worksans-thinitalic-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..76ce749dd613df19d195eea50f73de8c5b1d4475
GIT binary patch
diff --git a/static/includes/_font-worksans.scss b/static/includes/_font-worksans.scss
new file mode 100644
index 00000000..b1faf8d0
--- /dev/null
+++ b/static/includes/_font-worksans.scss
@@ -0,0 +1,26 @@
+@mixin worksans-font($type, $weight) {
+	@font-face {
+		font-family: 'Work Sans';
+		src: url('/static/fonts/WorkSans/worksans-#{$type}-webfont.woff2') format('woff2'),
+		     url('/static/fonts/WorkSans/worksans-#{$type}-webfont.woff') format('woff');
+		font-weight: $weight;
+		font-style: normal;
+	}
+	@font-face {
+		font-family: 'Work Sans';
+		src: url('/static/fonts/WorkSans/worksans-#{$type}italic-webfont.woff2') format('woff2'),
+		     url('/static/fonts/WorkSans/worksans-#{$type}italic-webfont.woff') format('woff');
+		font-weight: $weight;
+		font-style: italic;
+	}
+}
+
+@include worksans-font('thin', 100);
+@include worksans-font('extralight', 200);
+@include worksans-font('light', 300);
+@include worksans-font('regular', 400);
+@include worksans-font('medium', 500);
+@include worksans-font('semibold', 600);
+@include worksans-font('bold', 700);
+@include worksans-font('extrabold', 800);
+@include worksans-font('black', 900);
-- 
2.20.1