From 0a5d825859116a9a2a493bb1704ffe46983d9bf9 Mon Sep 17 00:00:00 2001
From: Nicolas ROCHE <nroche@entrouvert.com>
Date: Thu, 15 Aug 2019 17:59:16 +0200
Subject: [PATCH] fonts: add Exo 2 (#35389)

---
 README                                        |   7 +++++
 static/fonts/Exo2/exo2-black-webfont.woff     | Bin 0 -> 32712 bytes
 static/fonts/Exo2/exo2-black-webfont.woff2    | Bin 0 -> 25092 bytes
 .../fonts/Exo2/exo2-blackitalic-webfont.woff  | Bin 0 -> 35020 bytes
 .../fonts/Exo2/exo2-blackitalic-webfont.woff2 | Bin 0 -> 27228 bytes
 static/fonts/Exo2/exo2-bold-webfont.woff      | Bin 0 -> 34132 bytes
 static/fonts/Exo2/exo2-bold-webfont.woff2     | Bin 0 -> 26344 bytes
 .../fonts/Exo2/exo2-bolditalic-webfont.woff   | Bin 0 -> 36996 bytes
 .../fonts/Exo2/exo2-bolditalic-webfont.woff2  | Bin 0 -> 28880 bytes
 static/fonts/Exo2/exo2-extrabold-webfont.woff | Bin 0 -> 34088 bytes
 .../fonts/Exo2/exo2-extrabold-webfont.woff2   | Bin 0 -> 26272 bytes
 .../Exo2/exo2-extrabolditalic-webfont.woff    | Bin 0 -> 37020 bytes
 .../Exo2/exo2-extrabolditalic-webfont.woff2   | Bin 0 -> 28824 bytes
 .../fonts/Exo2/exo2-extralight-webfont.woff   | Bin 0 -> 32676 bytes
 .../fonts/Exo2/exo2-extralight-webfont.woff2  | Bin 0 -> 25260 bytes
 .../Exo2/exo2-extralightitalic-webfont.woff   | Bin 0 -> 38116 bytes
 .../Exo2/exo2-extralightitalic-webfont.woff2  | Bin 0 -> 29632 bytes
 static/fonts/Exo2/exo2-light-webfont.woff     | Bin 0 -> 33080 bytes
 static/fonts/Exo2/exo2-light-webfont.woff2    | Bin 0 -> 25436 bytes
 .../fonts/Exo2/exo2-lightitalic-webfont.woff  | Bin 0 -> 37600 bytes
 .../fonts/Exo2/exo2-lightitalic-webfont.woff2 | Bin 0 -> 29240 bytes
 static/fonts/Exo2/exo2-medium-webfont.woff    | Bin 0 -> 33820 bytes
 static/fonts/Exo2/exo2-medium-webfont.woff2   | Bin 0 -> 26084 bytes
 .../fonts/Exo2/exo2-mediumitalic-webfont.woff | Bin 0 -> 36776 bytes
 .../Exo2/exo2-mediumitalic-webfont.woff2      | Bin 0 -> 28508 bytes
 static/fonts/Exo2/exo2-regular-webfont.woff   | Bin 0 -> 33948 bytes
 static/fonts/Exo2/exo2-regular-webfont.woff2  | Bin 0 -> 26196 bytes
 .../Exo2/exo2-regularitalic-webfont.woff      | Bin 0 -> 36464 bytes
 .../Exo2/exo2-regularitalic-webfont.woff2     | Bin 0 -> 28252 bytes
 static/fonts/Exo2/exo2-semibold-webfont.woff  | Bin 0 -> 34724 bytes
 static/fonts/Exo2/exo2-semibold-webfont.woff2 | Bin 0 -> 26800 bytes
 .../Exo2/exo2-semibolditalic-webfont.woff     | Bin 0 -> 37404 bytes
 .../Exo2/exo2-semibolditalic-webfont.woff2    | Bin 0 -> 29184 bytes
 static/fonts/Exo2/exo2-thin-webfont.woff      | Bin 0 -> 31628 bytes
 static/fonts/Exo2/exo2-thin-webfont.woff2     | Bin 0 -> 24372 bytes
 .../fonts/Exo2/exo2-thinitalic-webfont.woff   | Bin 0 -> 37772 bytes
 .../fonts/Exo2/exo2-thinitalic-webfont.woff2  | Bin 0 -> 29224 bytes
 static/includes/_font-exo2.scss               |  26 ++++++++++++++++++
 38 files changed, 33 insertions(+)
 create mode 100644 static/fonts/Exo2/exo2-black-webfont.woff
 create mode 100644 static/fonts/Exo2/exo2-black-webfont.woff2
 create mode 100644 static/fonts/Exo2/exo2-blackitalic-webfont.woff
 create mode 100644 static/fonts/Exo2/exo2-blackitalic-webfont.woff2
 create mode 100644 static/fonts/Exo2/exo2-bold-webfont.woff
 create mode 100644 static/fonts/Exo2/exo2-bold-webfont.woff2
 create mode 100644 static/fonts/Exo2/exo2-bolditalic-webfont.woff
 create mode 100644 static/fonts/Exo2/exo2-bolditalic-webfont.woff2
 create mode 100644 static/fonts/Exo2/exo2-extrabold-webfont.woff
 create mode 100644 static/fonts/Exo2/exo2-extrabold-webfont.woff2
 create mode 100644 static/fonts/Exo2/exo2-extrabolditalic-webfont.woff
 create mode 100644 static/fonts/Exo2/exo2-extrabolditalic-webfont.woff2
 create mode 100644 static/fonts/Exo2/exo2-extralight-webfont.woff
 create mode 100644 static/fonts/Exo2/exo2-extralight-webfont.woff2
 create mode 100644 static/fonts/Exo2/exo2-extralightitalic-webfont.woff
 create mode 100644 static/fonts/Exo2/exo2-extralightitalic-webfont.woff2
 create mode 100644 static/fonts/Exo2/exo2-light-webfont.woff
 create mode 100644 static/fonts/Exo2/exo2-light-webfont.woff2
 create mode 100644 static/fonts/Exo2/exo2-lightitalic-webfont.woff
 create mode 100644 static/fonts/Exo2/exo2-lightitalic-webfont.woff2
 create mode 100644 static/fonts/Exo2/exo2-medium-webfont.woff
 create mode 100644 static/fonts/Exo2/exo2-medium-webfont.woff2
 create mode 100644 static/fonts/Exo2/exo2-mediumitalic-webfont.woff
 create mode 100644 static/fonts/Exo2/exo2-mediumitalic-webfont.woff2
 create mode 100644 static/fonts/Exo2/exo2-regular-webfont.woff
 create mode 100644 static/fonts/Exo2/exo2-regular-webfont.woff2
 create mode 100644 static/fonts/Exo2/exo2-regularitalic-webfont.woff
 create mode 100644 static/fonts/Exo2/exo2-regularitalic-webfont.woff2
 create mode 100644 static/fonts/Exo2/exo2-semibold-webfont.woff
 create mode 100644 static/fonts/Exo2/exo2-semibold-webfont.woff2
 create mode 100644 static/fonts/Exo2/exo2-semibolditalic-webfont.woff
 create mode 100644 static/fonts/Exo2/exo2-semibolditalic-webfont.woff2
 create mode 100644 static/fonts/Exo2/exo2-thin-webfont.woff
 create mode 100644 static/fonts/Exo2/exo2-thin-webfont.woff2
 create mode 100644 static/fonts/Exo2/exo2-thinitalic-webfont.woff
 create mode 100644 static/fonts/Exo2/exo2-thinitalic-webfont.woff2
 create mode 100644 static/includes/_font-exo2.scss

diff --git a/README b/README
index 0fabd32e..ec015e15 100644
--- a/README
+++ b/README
@@ -181,12 +181,19 @@ copyright notices:
 
 * Work Sans
   # Copyright (c) 2014-2015 Wei Huang (wweeiihhuuaanngg@gmail.com)
   #
   # This Font Software is licensed under the SIL Open Font License, Version 1.1.
   #
   # https://www.fontsquirrel.com/license/work-sans
 
+* Exo 2
+  # Copyright (c) 2013, Natanael Gama (www.ndiscovered.com . info(at)ndiscovered.com), with Reserved Font Name Exo.
+  #
+  # This Font Software is licensed under the SIL Open Font License, Version 1.1.
+  #
+  # https://www.fontsquirrel.com/license/exo-2
+
 ~~~~
 
 Some theme variant files have their own specific licenses; refer to
 static/$theme/README for details.
diff --git a/static/fonts/Exo2/exo2-black-webfont.woff b/static/fonts/Exo2/exo2-black-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..383cf6539377e7d8c9b4af7e70ac1718ee62c3a2
GIT binary patch
diff --git a/static/fonts/Exo2/exo2-black-webfont.woff2 b/static/fonts/Exo2/exo2-black-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..953211891569a46c66aa227577c291f605b2ce11
GIT binary patch
diff --git a/static/fonts/Exo2/exo2-blackitalic-webfont.woff b/static/fonts/Exo2/exo2-blackitalic-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..10cdc808a12bd707fb7c5b2cbcfd33ffd163733d
GIT binary patch
diff --git a/static/fonts/Exo2/exo2-blackitalic-webfont.woff2 b/static/fonts/Exo2/exo2-blackitalic-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..2c2610aaa6bbb1fc108e408feddb83a00a2df8e3
GIT binary patch
diff --git a/static/fonts/Exo2/exo2-bold-webfont.woff b/static/fonts/Exo2/exo2-bold-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..ca3795c5472256f118b1e3d49306aceaf55bad7d
GIT binary patch
diff --git a/static/fonts/Exo2/exo2-bold-webfont.woff2 b/static/fonts/Exo2/exo2-bold-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..9f4e122150768cc995365c7fb46e5609a933ccb8
GIT binary patch
diff --git a/static/fonts/Exo2/exo2-bolditalic-webfont.woff b/static/fonts/Exo2/exo2-bolditalic-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..d4216bd5c5c90f95c71296234153f903c7e06354
GIT binary patch
diff --git a/static/fonts/Exo2/exo2-bolditalic-webfont.woff2 b/static/fonts/Exo2/exo2-bolditalic-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..a282b3180db3e1d468fcf004d3b656dd0659b7c9
GIT binary patch
diff --git a/static/fonts/Exo2/exo2-extrabold-webfont.woff b/static/fonts/Exo2/exo2-extrabold-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..ddaf921feb8fdc84557e390a10d17cefc8dc6ed3
GIT binary patch
diff --git a/static/fonts/Exo2/exo2-extrabold-webfont.woff2 b/static/fonts/Exo2/exo2-extrabold-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..56a3670c219f9b3d4dd8ea3399f668e6b3892f82
GIT binary patch
diff --git a/static/fonts/Exo2/exo2-extrabolditalic-webfont.woff b/static/fonts/Exo2/exo2-extrabolditalic-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..d60840b6d6726fa3c3532a379bbd509ae646680a
GIT binary patch
diff --git a/static/fonts/Exo2/exo2-extrabolditalic-webfont.woff2 b/static/fonts/Exo2/exo2-extrabolditalic-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..73d5cd335ce63b4563b8ba148c87c03ebc442fbc
GIT binary patch
diff --git a/static/fonts/Exo2/exo2-extralight-webfont.woff b/static/fonts/Exo2/exo2-extralight-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..4940f120f9d25c76f5e5ed2b9e8ae1c1c1d08618
GIT binary patch
diff --git a/static/fonts/Exo2/exo2-extralight-webfont.woff2 b/static/fonts/Exo2/exo2-extralight-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..16b00099ea0de0541a92c22941abfcca22e2da00
GIT binary patch
diff --git a/static/fonts/Exo2/exo2-extralightitalic-webfont.woff b/static/fonts/Exo2/exo2-extralightitalic-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..36141da2c81cdc1a3dc48fc2f7ae483074901a9d
GIT binary patch
diff --git a/static/fonts/Exo2/exo2-extralightitalic-webfont.woff2 b/static/fonts/Exo2/exo2-extralightitalic-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..247a8a4e7035664d02ea6203b4b9197568db0790
GIT binary patch
diff --git a/static/fonts/Exo2/exo2-light-webfont.woff b/static/fonts/Exo2/exo2-light-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..2b9af3a20fd66dafce07ca12bcd08d1f690888bc
GIT binary patch
diff --git a/static/fonts/Exo2/exo2-light-webfont.woff2 b/static/fonts/Exo2/exo2-light-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..4e3dbe6cc8d05f0c76a68c280c5736157ce8ccbe
GIT binary patch
diff --git a/static/fonts/Exo2/exo2-lightitalic-webfont.woff b/static/fonts/Exo2/exo2-lightitalic-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..888cdf3f8fcea1590380be7f3eaadebef63f7bc7
GIT binary patch
diff --git a/static/fonts/Exo2/exo2-lightitalic-webfont.woff2 b/static/fonts/Exo2/exo2-lightitalic-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..fd673e8dc3eb3d883135c9739e1ec70577a03503
GIT binary patch
diff --git a/static/fonts/Exo2/exo2-medium-webfont.woff b/static/fonts/Exo2/exo2-medium-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..a11623f2a004e49e35ba30de17f2c85044be0038
GIT binary patch
diff --git a/static/fonts/Exo2/exo2-medium-webfont.woff2 b/static/fonts/Exo2/exo2-medium-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..d998fa12054d0e74e997fcfe1a3bf158551bc402
GIT binary patch
diff --git a/static/fonts/Exo2/exo2-mediumitalic-webfont.woff b/static/fonts/Exo2/exo2-mediumitalic-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..4a5aa2be5dbe263cf80a78300af664d4b8f8ce24
GIT binary patch
diff --git a/static/fonts/Exo2/exo2-mediumitalic-webfont.woff2 b/static/fonts/Exo2/exo2-mediumitalic-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..f3b735383e08743a18c85ecd6a765f0b831d171f
GIT binary patch
diff --git a/static/fonts/Exo2/exo2-regular-webfont.woff b/static/fonts/Exo2/exo2-regular-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..f85ae9d38666795273eb9cd33f13f21f95cde167
GIT binary patch
diff --git a/static/fonts/Exo2/exo2-regular-webfont.woff2 b/static/fonts/Exo2/exo2-regular-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..4ba18535fffa7569e14a0065ae244dc30eadd5d3
GIT binary patch
diff --git a/static/fonts/Exo2/exo2-regularitalic-webfont.woff b/static/fonts/Exo2/exo2-regularitalic-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..b7c4674ce2238c7718436253449e7648337d0e2c
GIT binary patch
diff --git a/static/fonts/Exo2/exo2-regularitalic-webfont.woff2 b/static/fonts/Exo2/exo2-regularitalic-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..33f3566f708098cc307062f01349f312a0beecf8
GIT binary patch
diff --git a/static/fonts/Exo2/exo2-semibold-webfont.woff b/static/fonts/Exo2/exo2-semibold-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..ef8ad1837bcef7b8c4447dccb2d9eb411cbaccbf
GIT binary patch
diff --git a/static/fonts/Exo2/exo2-semibold-webfont.woff2 b/static/fonts/Exo2/exo2-semibold-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..2c38e3b4271e662f8e5243270ef085a799d3323c
GIT binary patch
diff --git a/static/fonts/Exo2/exo2-semibolditalic-webfont.woff b/static/fonts/Exo2/exo2-semibolditalic-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..1b258d554130c1232a2e64747b9cf8ba4848ae8c
GIT binary patch
diff --git a/static/fonts/Exo2/exo2-semibolditalic-webfont.woff2 b/static/fonts/Exo2/exo2-semibolditalic-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..ad1c50ba4d576a798f0383d56346540bc784b1ee
GIT binary patch
diff --git a/static/fonts/Exo2/exo2-thin-webfont.woff b/static/fonts/Exo2/exo2-thin-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..c7054b56699f8f3a43c02bed2e00a2582895471d
GIT binary patch
diff --git a/static/fonts/Exo2/exo2-thin-webfont.woff2 b/static/fonts/Exo2/exo2-thin-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..2488fc78bd38f2fc7b054510ac15fb36c101fe3d
GIT binary patch
diff --git a/static/fonts/Exo2/exo2-thinitalic-webfont.woff b/static/fonts/Exo2/exo2-thinitalic-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..078528e26c8c95d856d707c2980c3fcb9a2691c3
GIT binary patch
diff --git a/static/fonts/Exo2/exo2-thinitalic-webfont.woff2 b/static/fonts/Exo2/exo2-thinitalic-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..bb6f87d396635ca68a5f3e2699f14ae1ab57c0e2
GIT binary patch
diff --git a/static/includes/_font-exo2.scss b/static/includes/_font-exo2.scss
new file mode 100644
index 00000000..0d501521
--- /dev/null
+++ b/static/includes/_font-exo2.scss
@@ -0,0 +1,26 @@
+@mixin exo2-font($type, $weight) {
+	@font-face {
+		font-family: 'Exo 2';
+		src: url('/static/fonts/exo2-#{$type}-webfont.woff2') format('woff2'),
+			 url('/static/fonts/exo2-#{$type}-webfont.woff') format('woff');
+		font-weight: $weight;
+		font-style: normal;
+	}
+	@font-face {
+		font-family: 'Exo 2';
+		src: url('/static/fonts/exo2-#{$type}italic-webfont.woff2') format('woff2'),
+			 url('/static/fonts/exo2-#{$type}italic-webfont.woff') format('woff');
+		font-weight: $weight;
+		font-style: italic;
+	}
+}
+
+@include exo2-font('thin', 100);
+@include exo2-font('extralight', 200);
+@include exo2-font('light', 300);
+@include exo2-font('regular', 400);
+@include exo2-font('medium', 500);
+@include exo2-font('semibold', 600);
+@include exo2-font('bold', 700);
+@include exo2-font('extrabold', 800);
+@include exo2-font('black', 900);
-- 
2.20.1